<?php
global $wpdb;
// Check if sync not run first time.
if (get_option("sync_run")<>"1") {
    function whmpress_not_synced() {
        ?>
        <div class="error">
            <h3>WHMpress Warning!</h3>
            <p>No data synced from hosting server, Please run <a href="admin.php?page=whmp-sync">Sync WHMCS</a> to use WHMpress</p>
        </div>
        <?php
    }
    add_action( 'admin_notices', 'whmpress_not_synced' );
}

// if WHMPress tables do not exist then show warning message
$Ts = $wpdb->get_results("SHOW TABLES LIKE '".whmp_get_configuration_table_name()."'",ARRAY_A);
if ( sizeof($Ts)==0 && get_option("sync_run")=="1" ) {
    function whmpress_not_synced() {
        ?>
        <div class="error">
            <h3>WHMpress Warning!</h3>
            <p>WHMpress data not found, Please run <a href="admin.php?page=whmp-sync">Sync WHMCS</a> to use WHMpress</p>
        </div>
        <?php
    }
    add_action( 'admin_notices', 'whmpress_not_synced' );
}

function whmp_admin_enqueue_styles($page) {
    #wp_enqueue_style('thickbox');
    #wp_enqueue_style('whmp-codemirror', WHMP_ADMIN_URL . '/css/codemirror.css', array());
    wp_enqueue_style('whmp-admin', WHMP_ADMIN_URL . '/css/style.css', array(), time(), 'all');
    
    
    #wp_enqueue_script( 'whmp-codemirror-js', plugin_dir_url(__FILE__) . 'js/codemirror.js', array('jquery'), '1.0.0', true );
    #wp_enqueue_script( 'whmp-codemirrorcss-js', plugin_dir_url(__FILE__) . 'js/mode/css/css.js', array('jquery'), '1.0.0', true );
}
add_action('admin_enqueue_scripts', 'whmp_admin_enqueue_styles');


// Adding link to top admin bar
add_action('wp_before_admin_bar_render', 'whmp_child_theme_creator_admin_bar_render', 100);
/**
 * Adds admin bar items for easy access to the theme creator and editor
 */
function whmp_child_theme_creator_admin_bar_render() {
    whmpress_add_admin_bar('WHMpress',"admin.php?page=whmp-dashboard");
    whmpress_add_admin_bar('Products/Services', 'admin.php?page=whmp-myservices', 'WHMpress');
    //whmpress_add_admin_bar('Groups', 'admin.php?page=whmp-groups', 'WHMpress');
    whmpress_add_admin_bar('Settings', 'admin.php?page=whmp-settings', 'WHMpress');
    whmpress_add_admin_bar('Sync WHMCS', 'admin.php?page=whmp-sync', 'WHMpress');
}

/**
 * Add's menu parent or submenu item.
 * @param string $name the label of the menu item
 * @param string $href the link to the item (settings page or ext site)
 * @param string $parent Parent label (if creating a submenu item)
 *
 * @return void
 * */
function whmpress_add_admin_bar($name, $href = '', $parent = '', $custom_meta = array()) {
    global $wp_admin_bar;
    if (!is_super_admin()
            || !is_admin_bar_showing()
            || !is_object($wp_admin_bar)
            || !function_exists('is_admin_bar_showing')) {
        return;
    }

    // Generate ID based on the current filename and the name supplied.
    $id = str_replace('.php', '', basename(__FILE__)) . '-' . $name;
    $id = preg_replace('#[^\w-]#si', '-', $id);
    $id = strtolower($id);
    $id = trim($id, '-');

    $parent = trim($parent);

    // Generate the ID of the parent.
    if (!empty($parent)) {
        $parent = str_replace('.php', '', basename(__FILE__)) . '-' . $parent;
        $parent = preg_replace('#[^\w-]#si', '-', $parent);
        $parent = strtolower($parent);
        $parent = trim($parent, '-');
    }

    // links from the current host will open in the current window
    $site_url = site_url();

    $meta_default = array();
    $meta_ext = array( 'target' => '_self' ); // external links open in new tab/window then mention _blank here

    $meta = (strpos($href, $site_url) !== false) ? $meta_default : $meta_ext;
    $meta = array_merge($meta, $custom_meta);

    $wp_admin_bar->add_node(array(
        'parent' => $parent,
        'id' => $id,
        'title' => $name,
        'href' => $href,
        'meta' => $meta,
    ));
}



function whmp_add_pages() {
   // The first parameter is the Page name(admin-menu), second is the Menu name(menu-name)
   //and the number(5) is the user level that gets access
   // Icons from http://melchoyce.github.io/dashicons/
    add_menu_page('WHMpress Dashboard', 'WHMpress', 'manage_options', 'whmp-dashboard', 'whmp_dashboard', WHMP_ADMIN_URL . "/images/whitelogo-16.png" ,'81.69856');
    
    //$manage_options_cap = apply_filters( 'wpseo_manage_options_capability', 'manage_options' );
    $submenu_pages = array(
        array(
			'whmp-dashboard',
			'',
			"Dashboard",
			'manage_options',
			'whmp-dashboard',
			'whmp_load_page',
			null,
		),
        array(
			'whmp-dashboard',
			'',
			"Products/Services",
			'manage_options',
			'whmp-services',
			'whmp_load_page',
			null,
		),
        /*array(
			'whmp-dashboard',
			'',
			"Pricing Table Groups",
			'manage_options',
			'whmp-groups',
			'whmp_load_page',
			null,
		),*/
        array(
			'whmp-dashboard',
			'',
			"Settings",
			'manage_options',
			'whmp-settings',
			'whmp_load_page',
			null,
		),
        array(
			'whmp-dashboard',
			'',
			"Sync WHMCS",
			'manage_options',
			'whmp-sync',
			'whmp_load_page',
			null,
		),
        array(
			'whmp-dashboard',
			'',
			"<span style='color:#FA3C00'>Extensions</span>",
			'manage_options',
			'whmp-extensions',
			'whmp_load_page',
			null,
		),
    );
    
    // Allow submenu pages manipulation
    $submenu_pages = apply_filters( 'whmp_submenu_pages', $submenu_pages );
    
    // Loop through submenu pages and add them
	if ( count( $submenu_pages ) ) {
		foreach ( $submenu_pages as $submenu_page ) {

			// Add submenu page
			$admin_page = add_submenu_page( $submenu_page[0], $submenu_page[2] . ' - ' . 'WHMpress:', $submenu_page[2], $submenu_page[3], $submenu_page[4], $submenu_page[5] );

			// Check if we need to hook
			if ( isset( $submenu_page[6] ) && null != $submenu_page[6] && is_array( $submenu_page[6] ) && count( $submenu_page[6] ) > 0 ) {
				foreach ( $submenu_page[6] as $submenu_page_action ) {
					add_action( 'load-' . $admin_page, $submenu_page_action );
				}
			}
		}
	}
    
    global $submenu;
	if ( isset( $submenu['whmp-dashboard'] ) && current_user_can( $manage_options_cap ) ) {
		$submenu['whmp-dashboard'][0][0] = 'Dashboard';
	}
    
    #add_submenu_page('whmp-dashboard','Styles','Styles','administrator','whmp-custom-css','whmp_css');
    #add_submenu_page('whmp-dashboard','Import','Import','administrator','whmp-import','whmp_import');
    #add_submenu_page('whmp-dashboard','Export','Export','administrator','whmp-export','whmp_export');
}
function whmp_load_page() {
    if ( isset( $_GET['page'] ) ) {
        switch($_GET["page"]) {
            case "whmp-dashboard":
                require_once(WHMP_ADMIN_DIR . "/dashboard.php");
                break;
            case "whmp-settings":
                require_once(WHMP_ADMIN_DIR . "/settings.php");
                break;
            case "whmp-services":
                require_once(WHMP_ADMIN_DIR . "/services.php");
                break;
            case "whmp-groups":
                require_once(WHMP_ADMIN_DIR . "/groups.php");
                break;
            case "whmp-sync":
                require_once(WHMP_ADMIN_DIR . "/sync.php");
                break;
            case "whmp-extensions":
                require_once(WHMP_ADMIN_DIR . "/extensions.php");
                break;
            default:
                require_once(WHMP_ADMIN_DIR . "dashbaord.php");
        }
        /*if (file_exists(WHMP_ADMIN_DIR . "/".$_GET['page'].".php")) {
            require_once(WHMP_ADMIN_DIR . "/".$_GET['page'].".php");
        } else {
            require_once(WHMP_ADMIN_DIR . "dashbaord.php");
        }*/
	}
}
function whmp_css() {
    include_once (WHMP_ADMIN_DIR . "/custom-css.php");
}
function whmp_dashboard() {
    include_once WHMP_ADMIN_DIR."/dashboard.php";
}
function whmp_services() {
    include_once WHMP_ADMIN_DIR."/services.php";
}
function whmp_import() {
    include_once WHMP_ADMIN_DIR."/import.php";
}
function whmp_export() {
    include_once WHMP_ADMIN_DIR."/export.php";
}
function whmp_settings() {
    include_once WHMP_ADMIN_DIR."/settings.php";
}
function whmp_sync_db() {
    include_once WHMP_ADMIN_DIR."/sync.php";
}
add_action('admin_menu', 'whmp_add_pages');




add_action('admin_head', 'whmpress_print_shortcodes_in_js');
#add_action('admin_head', 'my_add_tinymce');
function whmpress_print_shortcodes_in_js(){
	?>
	<script type="text/javascript">
		var my_shortcodes = ['[haha]','[hehe]'];
	</script>
	<?php
}


add_action('admin_head', 'whmpress_add_my_tc_button');
function whmpress_add_my_tc_button() {
    global $typenow;
    // check user permissions
    if ( !current_user_can('edit_posts') && !current_user_can('edit_pages') ) {
   	return;
    }
    // verify the post type
    if( ! in_array( $typenow, array( 'post', 'page' ) ) )
        return;
	// check if WYSIWYG is enabled
	if ( get_user_option('rich_editing') == 'true') {
		add_filter("mce_external_plugins", "whmpress_add_tinymce_plugin");
		add_filter('mce_buttons', 'whmpress_register_my_tc_button');
	}
}
function whmpress_add_tinymce_plugin($plugin_array) {
   	$plugin_array['whmpress_tc_button'] = WHMP_ADMIN_URL . '/js/shortcodes.js.php?' . time();
   	return $plugin_array;
}
function whmpress_register_my_tc_button($buttons) {
   array_push($buttons, "whmpress_tc_button");
   return $buttons;
}
