<?php
/**
 * @package Admin
 * @todo    Dashboard page for WHMpress admin panel
 */

if ( ! defined( 'WHMP_VERSION' ) ) {
	header( 'Status: 403 Forbidden' );
	header( 'HTTP/1.1 403 Forbidden' );
	exit();
}
global $wpdb;

if (isset($_GET["removeSettings"])) {
    // Removing all tables and data.
    echo "Removing cached data ...<br />";
    global $Tables;
    foreach($Tables as $table) {
        $table_name_function = 'whmp_get_'.$table.'_table_name';
        $Q = "DROP TABLE `".$table_name_function()."`";
        $wpdb->query($Q);
    }
    
    // Removing settings data.
    // Coming soon.
}
?>
<div class="wrap">
    <div class="whmp-main-title"><span class="whmp-title">WHMpress</span> Dashboard</div>
    
    <div>
        <div class="whmpress_panel whmpress_50">
            <div>
                <h3>General</h3>
                <p>Watch this video to quickly learn about the use of WHMpress</p>
                <p><a href="#" class="button button-primary">Introduction Tour</a></p>
                <br />
                <p>If you want to reset all WHMpress as it was newly installed, press this button.</p>
                <p><button onclick="Reset()" class="button button-primary">Reset WHMpress</button></p>
            </div>
        </div>
        <div class="whmpress_panel whmpress_50">
            <div>
                <h3>System Info</h3>
                <p><strong>WHMpress Version</strong>: <?php echo WHMP_VERSION ?><br />
                <strong>WHMCS Version</strong>: <?php echo $wpdb->get_var("SELECT `value` FROM `".whmp_get_configuration_table_name()."` WHERE `setting`='Version'"); ?><br />
                <strong>CompanyName</strong>: <?php echo $wpdb->get_var("SELECT `value` FROM `".whmp_get_configuration_table_name()."` WHERE `setting`='CompanyName'"); ?><br />
                <strong>Language</strong>: <?php echo $wpdb->get_var("SELECT `value` FROM `".whmp_get_configuration_table_name()."` WHERE `setting`='Language'"); ?><br />
                <strong>E-Mail</strong>: <?php echo $wpdb->get_var("SELECT `value` FROM `".whmp_get_configuration_table_name()."` WHERE `setting`='email'"); ?><br />
                <strong>Last Synced</strong>: <span style="color: #CC0000;"><?php echo get_option('sync_time') ?></span>
                </p>
                <p>
                <strong>Domains</strong>: <?php echo $wpdb->get_var("SELECT COUNT(*) FROM `".whmp_get_domain_pricing_table_name()."`"); ?><br />
                <strong>Products</strong>: <?php echo $wpdb->get_var("SELECT COUNT(*) FROM `".whmp_get_products_table_name()."`"); ?><br />
                <strong>Product Groups</strong>: <?php echo $wpdb->get_var("SELECT COUNT(*) FROM `".whmp_get_product_group_table_name()."`"); ?><br />
                <strong>Currencies</strong>: <?php echo $wpdb->get_var("SELECT COUNT(*) FROM `".whmp_get_currencies_table_name()."`"); ?>
                </p>
            </div>
        </div>
    </div>
</div>

<script>
function Reset() {
    if (!confirm("Warning! All cached data and all settings of WHMpress will removed.\n\n\nAre you sure?")) return false;
    window.location.href = "admin.php?page=whmp-dashboard&removeSettings";
}
</script>