<?php
/**
 * @package Admin
 * @todo    Services page for WHMpress admin panel
 */

if ( ! defined( 'WHMP_VERSION' ) ) {
	wp_die("Direct acces not allowed by WHMPress", "Forbidden");
}

global $wpdb; ?>
<div class="wrap">
    <div class="whmp-main-title"><span class="whmp-title">WHMpress</span> Services</div>
    
    <div class="updated">
        <p>
        This page lists all the products & services you have configured in WHMCS installation. You will find all services in their respective tabs. It gives you an overview of the services you have without leaving WordPress. Plus you may also use this page to find the Service/Product ID to use in Shortcode. 
    If you find this page empty, click Sync WHMCS to cache your selling related settings from WHMCS.
        </p>
    </div>
    
    <?php
    $Q = "SELECT DISTINCT `type` FROM `".whmp_get_products_table_name()."` WHERE `type`<>''";
    $tabs = whmp_get_service_types();
    ?>
    
    <style>
    .mytr, .mytr th, .mytr th:hover {
        background-color: #666666 !important;
        color:#FFFFFF !important;
    }
    </style>
    
    <ul class='tabs'>
        <?php $k=1;
        foreach($tabs as $key=>$tab): ?>
        <li><a href='#tab<?php echo $k ?>'><?php echo $tab ?></a></li>
        <?php $k++; endforeach; ?>
        <li><a href="#domains">Domains</a></li>
        <li><a href="#currencies">Currencies</a></li>
    </ul>
    
    <?php $k=1;
    foreach($tabs as $key=>$tab): ?>
    <div id='tab<?php echo $k ?>'>
        <table class="fancy" style="width:100%">
            <thead>
                <tr class="mytr">
                    <th style="width:25px">ID</th>
                    <th style="width:30%">Name</th>
                    <th>Description</th>
                </tr>
            </thead>
            <tbody>
                <?php
                $groups = $wpdb->get_results("SELECT `id`,`name`,`hidden` FROM `".whmp_get_product_group_table_name()."` ORDER BY `order`",ARRAY_A);
                foreach($groups as $group) {
                    $rows = $wpdb->get_results("SELECT `id`, `name`,`description`,`hidden` FROM `".whmp_get_products_table_name()."` WHERE `gid`='{$group["id"]}' AND `type`='{$key}' ORDER BY `name`");
                    if (is_array($rows) && sizeof($rows)>0) {
                        $hidden = $group["hiddne"]=="on"?" (<i>Hidden</i>)":"";
                        echo "<tr><th colspan='3' style='text-align:center'>Group: ".$group["name"]." ({$group["id"]}) $hidden</th></tr>";
                        foreach($rows as $row): ?>
                        <tr>
                            <td><?php echo $row->id; ?></td>
                            <td><?php echo $row->name; if ($row->hidden=="on") echo " (<i>Hidden<i>)" ?></td>
                            <td><?php echo $row->description ?></td>
                        </tr>
                        <?php endforeach;
                    }
                } ?>
            </tbody>
        </table>
    </div>
    <?php $k++; endforeach; ?>
    
    <div id="domains">
        <?php $Q = "SELECT `id`,`extension` FROM `".whmp_get_domain_pricing_table_name()."` ORDER BY `order`";
        $rows = $wpdb->get_results($Q,ARRAY_A); ?>
        <div>You are selling <?php echo count($rows) ?> domain(s)</div>
        <table class="fancy" style="width:100%">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Domain</th>
                </tr>
            </thead>
            <tbody>
            <?php foreach($rows as $row): ?>
            <tr>
                <td><?php echo $row["id"] ?></td>
                <td><?php echo $row["extension"] ?></td>
            </tr>
            <?php endforeach; ?>
            </tbody>
        </table>
    </div>
    
    <div id="currencies">
        <?php $Q = "SELECT * FROM `".whmp_get_currencies_table_name()."`";
        $rows = $wpdb->get_results($Q,ARRAY_A); ?>
        <table class="fancy" style="width:100%">
            <thead>
                <tr>
                    <th>ID</th>
                    <th>Code</th>
                    <th>Prefix</th>
                    <th>Suffix</th>
                </tr>
            </thead>
            <tbody>
            <?php foreach($rows as $row): ?>
            <tr <?php if ($row["default"]=="1") echo "style='font-weight:bold'" ?>>
                <td><?php echo $row["id"] ?><?php if ($row["default"]=="1") echo " <sup>[default]</sup>" ?></td>
                <td><?php echo $row["code"] ?></td>
                <td><?php echo $row["prefix"] ?></td>
                <td><?php echo ($row["suffix"]); ?></td>
            </tr>
            <?php endforeach; ?>
            </tbody>
        </table>
    </div>
</div>



<script type="text/javascript">
jQuery(document).ready(function () {
    jQuery('ul.tabs').each(function(){
    // For each set of tabs, we want to keep track of
    // which tab is active and it's associated content
    var $active, $content, $links = jQuery(this).find('a');

    // If the location.hash matches one of the links, use that as the active tab.
    // If no match is found, use the first link as the initial active tab.
    $active = jQuery($links.filter('[href="'+location.hash+'"]')[0] || $links[0]);
    $active.addClass('active');

    $content = jQuery($active[0].hash);

    // Hide the remaining content
    $links.not($active).each(function () {
        jQuery(this.hash).hide();
    });

    // Bind the click event handler
    jQuery(this).on('click', 'a', function(e){
      // Make the old tab inactive.
      $active.removeClass('active');
      $content.hide();

      // Update the variables with the new link and content
      $active = jQuery(this);
      $content = jQuery(this.hash);

      // Make the tab active.
      $active.addClass('active');
      $content.show();

      // Prevent the anchor's default click action
      e.preventDefault();
    });
  });
});
</script>