<?php

// All shortcodes and their functions are defined in array to recognise
$whmp_shortcodes_list = array(
    "whmpress_price" => "whmpress_price_function",
    
    "whmpress_price_table" => "whmpress_price_table_function",
    "whmpress_price_matrix" => "whmpress_price_table_function",
    
    "whmpress_price_table_domain" => "whmpress_price_table_domain_function",
    "whmpress_price_matrix_domain" => "whmpress_price_table_domain_function",
    
    "whmpress_order_combo" => "whmpress_order_combo_function",
    "whmpress_order_button" => "whmpress_order_button_function",
    "whmpress_order_link" => "whmpress_order_link_function",
    "whmpress_order_url" => "whmpress_order_url_function",
    "whmpress_domain_search" => "whmpress_domain_search_function",
    "whmpress_currency" => "whmpress_currency_function",
    "whmpress_currency_combo" => "whmpress_currency_combo_function",
    "whmpress_currency_combo_fancy" => "whmpress_currency_combo_fancy_function",
    "whmpress_name" => "whmpress_name_function",
    "whmpress_description" => "whmpress_description_function",
    "whmpress_price_box" => "whmpress_price_box_function",
    "whmpress_domain_search_ajax" => "whmpress_domain_search_ajax_function",
    "whmpress_domain_search_ajax_results" => "whmpress_domain_search_ajax_results_function",
    "whmpress_domain_search_extended_ajax" => "whmpress_domain_search_ajax_function",
    "whmpress_domain_search_extended_ajax_results" => "whmpress_domain_search_extended_ajax_results_function",
    "whmpress_domain_search_bulk" => "whmpress_domain_search_bulk_function",
    "whmpress_domain_whois" => "whmpress_whois_function",
    "whmpress_price_table_group" => "whmpress_price_table_group_function",
    
    #"whmpress_geek" => "whmpress_geek_function",
    #"whmpress_cyearly" => "whmp_shortcode_yearly",
    #"whmpress_cmonthly" => "whmp_shortcode_cmonthly",
);

// Adding all shortcodes mentioned in array above
foreach($whmp_shortcodes_list as $shortcode=>$func) {
    add_shortcode($shortcode, $func);
}

function whmpress_price_table_group_function($atts) {
/**
 * id = Group's ID required
 */
    $group = whmp_get_group_full($atts["id"]);
    //show_array($group);
    
    if (count($group["plans"])=="1") $cols = "12";
    elseif (count($group["plans"])=="2") $cols = "9";
    elseif (count($group["plans"])=="3") $cols = "4";
    elseif (count($group["plans"])=="4") $cols = "3";
    elseif (count($group["plans"])=="5") $cols = "2";
    elseif (count($group["plans"])=="6") $cols = "2";
    else $cols = "3";
    $color = $group["color"];
    $HTML = '<div class="pt-container">';
    foreach($group["plans"] as $plan) {
        if ($group["important"]==$plan["product_id"]) {
            $active  = "active";
            if ($group["ribbon_text"]<>"") {
                $ribon_text =
                '<div class="pt-ribbon-wrapper">
                    <div class="pt-ribbon">
                         '.$group["ribbon_text"].'
                    </div>
                </div>';
            }
        } else {
            $active  = "";
            $ribon_text = "";
        }
        //show_array($plan);
        $description = str_replace("<br />","\n",$plan["description"]);
        $description = str_replace("<br/>","\n",$description);
        $description = explode("\n",$description);
        
        $rows = $group["rows"];
        if ($rows==0 || $rows>sizeof($description)) $rows=sizeof($description);
        $Desc = "";
        for($x=0; $x<$rows; $x++) {
            $Desc .= "
                <div class=\"pt-row\" style='text-align:left'>
                    <i class=\"pt-row-icon ok fa fa-check\"></i> {$description[$x]}
                </div>
            ";
        }
        
        $striped = $group["alternate_rows"]=="1"?"striped hover":"";
        
        //$price = '<span class="pt-currency">'.whmp_get_default_currency_prefix()."<span>";
        $price = whmpress_price_function( array(
            "billingcycle"=>$group["billingcycle"],
            "id"=>$plan["product_id"],
            "currency"=>$group["currency"],
            //"html_id"=>$group["html_id"],
            //"html_class"=>$group["html_class"],
            "decimals"=>$group["decimals"],
            "decimals_tag"=>$group["decimals_tag"],
            "hide_decimal"=>$group["hide_decimal"],
            "prefix"=>$group["prefix"],
            "suffix"=>$group["suffix"],
            "show_duration"=>$group["show_duration"],
            "show_duration_as"=>$group["show_duration_as"],
            "convert_monthly"=>$group["convert_monthly"],
        ) );
        $button_text = $group["button_text"]==""?"Buy Now":$group["button_text"];
        $url = whmp_get_installation_url()."/cart.php?pid={$plan["product_id"]}&a=add&currency={$group["currency"]}&billingcycle={$group["billingcycle"]}";
        //var_dump($price);
        $HTML .= <<<EOT
                <div class="col-md-{$cols}">
                    <div class="pricing-table {$active} {$color}">
                        <div class="pt-header">
                            {$ribon_text}
                            <h3 class="pt-title">{$plan["name"]}</h3>
                            <h4 class="pt-price">$price</h4>
                            <!--p class="pt-description"></p-->
                        </div>   <!-- end .pt-header -->
                        <div class="pt-body {$striped}">
                            $Desc
                        </div>   <!-- end .pt-body -->
                        <div class="pt-footer">
                            <button onclick='window.location.href="{$url}"' type="button" class="pt-button">{$button_text}</button>
                        </div>   <!-- end .pt-footer -->
                    </div>   <!-- end .pricing-table -->
                </div>   <!-- end .col-md-3 -->
EOT;
    }
    $HTML .= "</div>";
    return $HTML;
}

function whmpress_whois_function($atts) {
/**
 * Displays a form for getting whois info of multiple line provided domains
 * 
 * List of parameters
 * text_class = HTML class for input search text box
 * button_class = HTML class for submit button of form
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * placeholder = placeholder text for input search textbox
 * button_text = Search button text
 * result_text = HTML class for output result
 */

    # Checking parameters
    $text_class = isset($atts["text_class"])?$atts["text_class"]:"";
    $button_class = isset($atts["button_class"])?$atts["button_class"]:"";
    $html_class = isset($atts["html_class"])?$atts["html_class"]:""; if ($html_class=="") $html_class = "whmpress whmpress_domain_whois";
    $html_id = isset($atts["html_id"])?$atts["html_id"]:"";
    $placeholder = isset($atts["placeholder"])?$atts["placeholder"]:"";
    $button_text = !empty($atts["button_text"])?$atts["button_text"]:"Get Whois";
    $result_text_class = isset($atts["result_text_class"])?$atts["result_text_class"]:"";
    
    # Generating output form    
    $str = '<form method="post">'."\n";
    $str .= '<input required="required" class="'.$text_class.'" placeholder="'.$placeholder.'" name="whois_domain" value="'.@$_POST["whois_domain"].'">'."\n";
    $str .= '<button class="'.$button_class.'">'.$button_text.'</button>'."\n";
    $str .= "</form>\n";
    
    if (isset($_POST["whois_domain"])) {
        include_once (WHMP_PLUGIN_DIR . "/includes/whois.class.php");
        $whois = new Whois;
        
        $str .= "<pre class='$result_text_class'>".$whois->whoislookup($_POST["whois_domain"],".com",true)."</pre>";
    }
    
    return "<div class='$html_class' id='$html_id'>" . $str . "</div>";
}

function whmpress_domain_search_bulk_function($atts) {
/**
 * Displays a form for getting whois info of multiple line provided domains
 * 
 * List of parameters
 * text_class = HTML class for input search text box
 * button_class = HTML class for submit button of form
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * placeholder = placeholder text for input search textbox
 * button_text = Search button text
 */
 
    # Checking parameters
    $text_class = isset($atts["text_class"])?$atts["text_class"]:"";
    $button_class = isset($atts["button_class"])?$atts["button_class"]:"";
    $html_class = isset($atts["html_class"])?$atts["html_class"]:""; if ($html_class=="") $html_class = "whmpress whmpress_domain_search_bulk";
    $html_id = isset($atts["html_id"])?$atts["html_id"]:"";
    $placeholder = isset($atts["placeholder"])?$atts["placeholder"]:"";
    $button_text = !empty($atts["button_text"])?$atts["button_text"]:"Search";
    
    # Generating output form    
    $str = '<form method="post">'."\n";
    $str .= '<textarea required="required" class="'.$text_class.'" placeholder="'.$placeholder.'" name="search_bulk_domain">'.@$_POST["search_bulk_domain"].'</textarea>'."\n";
    $str .= '<button class="'.$button_class.'">'.$button_text.'</button>'."\n";
    $str .= "</form>\n";
    
    $HTML = "";
    if (isset($_POST["search_bulk_domain"])) {
        $HTML .= "<div class='result-div'>";
        $domains = @$_POST["search_bulk_domain"];
        $domains = explode("\n",$domains);
        
        include_once (WHMP_PLUGIN_DIR . "/includes/whois.class.php");
        $whois = new Whois;
        
        global $wpdb;
        
        foreach($domains as $domain) {
            if (trim($domain)<>""):
            $domain = ltrim($domain, '//');
            if (substr(strtolower($domain), 0, 7) == "http://") $domain = substr($domain, 7);
            if (substr(strtolower($domain), 0, 8) == "https://") $domain = substr($domain, 8);
            if (strtolower(substr($domain["host"],"0,4"))=="www.") $domain["host"] = substr($domain["host"],4);
            if (strtolower(substr($domain["host"],"0,3"))=="ww.") $domain["host"] = substr($domain["host"],3);
            
            $ext = whmp_get_domain_extension($domain);
            $onlydomain = str_replace("." . $ext, "", $domain);
                        
            if ($ext == $onlydomain) {
                $ext = "com";
                $onlydomain .= ".com";
            }
            $result = $whois->whoislookup($domain, $ext);
                    
            if ($result) {
                $ext = ".".ltrim($ext,".");
                $Dom = $domain;
                $Message = "[domain-name]";
                $Message = str_replace("[domain-name]", $Dom, $Message);
                if ($wpdb->get_var("SELECT COUNT(*) FROM `".whmp_get_domain_pricing_table_name()."` WHERE `extension`='$ext'")>0) {
                    $price = whmp_get_domain_extension_price($ext);
                    $button = @$price[ get_option('default_currency_symbol',"prefix") ].$price["msetupfee"];
                    if (!empty($price["msetupfee"]))
                        $button .= "<a href='".get_option("whmcs_url")."cart.php?a=add&domain=register&sld={$onlydomain}&tld={$ext}'>Register Domain</a>";
                    else
                        $button = "";
                } else
                    $button = "";
                $HTML .= "
                <div class='found-div'><span><i class='fa fa-check'></i> $Message</span>
                $button
                <div style='clear:both'></div>
                </div>\n";
            } else {
                $Dom = $domain;
                $Message = "[domain-name]";
                $Message = str_replace("[domain-name]", $Dom, $Message);
                $HTML .= "<div class='not-found-div'>
                    <span><i class='fa fa-warning'></i> $Message<span></div>\n";
            }
            endif;
        }
        $HTML .= "</div>";
    }
    
    # Returning output form
    return "<div class='$html_class' id='$html_id'>" . $str . $HTML . "</div>";
}


function whmpress_domain_search_extended_ajax_results_function($atts) {
/**
 * Displays whois search result submitted by whmpress_domain_search_extended_ajax form
 * 
 * List of parameters
 * searchonly = * for all domain or get result only for specific extensions comma seperated
 * html_class = HTML class for wrapper
 */
    # Checking for parameters
    $searchonly = !empty($atts["searchonly"])?$atts["searchonly"]:"*";
    $html_class = @$atts["html_class"]; if ($html_class=="") $html_class="whmpress whmpress_domain_search_extended_ajax_results";
 
    //include_once "pages/domain_search_result.php";
    if (isset($_GET["search_domain"])) {
        $str = '<div id="search_result_div">'."\n";
        $str .= '<div style="font-size:30px;text-align: center;">'."\n";
        $str .= '<i class="fa fa-spinner fa-spin"></i>'."\n";
        $str .= "</div>\n";
        $str .= "</div>\n";
        
        if (isset($_GET["ext"])) $_GET["search_domain"] .= $_GET["ext"];
        
        $str .= "<script>
        jQuery(function(){
            jQuery.post(MyAjax.ajaxurl, {'domain':'{$_GET["search_domain"]}','action':'whmpress_action','do':'getDomainData','searchonly':'{$searchonly}'}, function(data){
                jQuery(\"#search_result_div\").html(data);
            });
            jQuery(document).on('click', \"#load-more-div button\", function () {
                jQuery(\"#load-more-div\").remove();
                //jQuery(\"#search_result_div\").append('<div id=\"waiting_div\" style=\"font-size:30px;text-align: center;\"><i class=\"icon-spinner fa-spin\"></i></div>');
                jQuery(\".result-div\").append('<div id=\"waiting_div\" style=\"font-size:30px;text-align: center;\"><i class=\"fa fa-spinner fa-spin\"></i></div>');
                page++;
                jQuery.post(MyAjax.ajaxurl, {'domain':'{$_GET["search_domain"]}','action':'whmpress_action','do':'loadWhoisPage','page':page,'searchonly':'{$searchonly}'}, function(data){
                    jQuery(\"#waiting_div\").remove();
                    jQuery(\".result-div\").append(data);
                });
            });
        });
        </script>\n";
    } else {
        $str = "";
    }
    
    return "<div class='$html_class'>" . $str . "</div>";
}


function whmpress_domain_search_ajax_function($atts) {
/**
 * Displays a form for getting whois info of domains
 * 
 * List of parameters
 * action = Action url for form. Form will submit on this url
 * text_class = HTML class for input search text box
 * button_class = HTML class for submit button of form
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * placeholder = placeholder text for input search textbox
 * button_text = Search button text
 */
 
    # Checking parameters
    $text_class = isset($atts["text_class"])?$atts["text_class"]:"";
    $button_class = isset($atts["button_class"])?$atts["button_class"]:"";
    $action = isset($atts["action"])?$atts["action"]:"";
    $html_class = isset($atts["html_class"])?$atts["html_class"]:""; if ($html_class=="") $html_class = "whmpress whmpress_domain_search_ajax";
    $html_id = isset($atts["html_id"])?$atts["html_id"]:"";
    $placeholder = isset($atts["placeholder"])?$atts["placeholder"]:"";
    $button_text = !empty($atts["button_text"])?$atts["button_text"]:"Search";
    
    # Generating output form        
    $str = '<form action="'.$action.'" method="get">'."\n";
    if ($action=="") {
        foreach($_GET as $k=>$v) {
            if ($k<>"search_domain")
                $str .= "<input type='hidden' name='$k' value=\"$v\" />\n";
        }
    }
    $str .= '<input required="required" class="'.$text_class.'" placeholder="'.$placeholder.'" value="'.@$_GET["search_domain"].'" type="search" name="search_domain" />'."\n";
    $str .= '<button class="'.$button_class.'">'.$button_text.'</button>'."\n";
    $str .= "</form>\n";
    
    # Returning output form
    return "<div class='$html_class' id='$html_id'>" . $str . "</div>";
}


function whmpress_domain_search_ajax_results_function($atts) {
/**
 * Displays whois search result submitted by whmpress_whois_search form
 * 
 * List of parameters
 * searchonly = * for all domain or get result only for specific extensions comma seperated
 * html_class = HTML class for wrapper
 */
    # Checking for parameters
    $searchonly = !empty($atts["searchonly"])?$atts["searchonly"]:"*";
    $html_class = @$atts["html_class"]; if ($html_class=="") $html_class = "whmpress whmpress_domain_search_ajax_results";
 
    //include_once "pages/domain_search_result.php";
    if (isset($_GET["search_domain"])) {
        $str = '<div id="search_result_div">'."\n";
        $str .= '<div style="font-size:30px;text-align: center;">'."\n";
        $str .= '<i class="fa fa-spinner fa-spin"></i>'."\n";
        $str .= "</div>\n";
        $str .= "</div>\n";
        
        if (isset($_GET["ext"])) $_GET["search_domain"] .= $_GET["ext"];
        
        $str .= "<script>
        jQuery(function(){
            jQuery.post(MyAjax.ajaxurl, {'domain':'{$_GET["search_domain"]}','action':'whmpress_action','do':'getDomainData','searchonly':'{$searchonly}','skip_extra':'1','page':'1'}, function(data){
                jQuery(\"#search_result_div\").html(data);
            });
            jQuery(document).on('click', \"#load-more-div button\", function () {
                jQuery(\"#load-more-div\").remove();
                jQuery(\".result-div\").append('<div id=\"waiting_div\" style=\"font-size:30px;text-align: center;\"><i class=\"fa fa-spinner fa-spin\"></i></div>');
                page++;
                jQuery.post(MyAjax.ajaxurl, {'domain':'{$_GET["search_domain"]}','action':'whmpress_action','skip_extra':'1','do':'loadWhoisPage','page':page,'searchonly':'{$searchonly}'}, function(data){
                    jQuery(\"#waiting_div\").remove();
                    jQuery(\".result-div\").append(data);
                });
            });
        });
        </script>\n";
    } else {
        $str = "";
    }
    
    return "<div class='$html_class'>" . $str . "</div>";
}

function whmpress_price_box_function($atts) {
/**
 * Shows price box
 * 
 * List of parameters
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * box_type = Box type, e.g. default,
 * id = relid match from whmcs mysql table
 * billingcycle = Billing cycle e.g. annually, monthly etc.
 * show_price = Display price or not.
 * show_combo = Show combo or not, No, Yes
 * show_button = Show submit button or not
 * currency = Currency for price
 */
    
    # Checking parameters
    $html_class = !empty($atts["html_class"])?$atts["html_class"]:""; if ($html_class=="") $html_class = "whmpress whmpress_price_box";
    $html_id = !empty($atts["html_id"])?$atts["html_id"]:"";
    $box_type = !empty($atts["box_type"])?$atts["box_type"]:"Default";
    $id = !empty($atts["id"])?$atts["id"]:"0";
    $billingcycle = !empty($atts["billingcycle"])?$atts["billingcycle"]:whmpress_get_option("billingcycle");
    $show_price = !empty($atts["show_price"])?$atts["show_price"]:"Yes";
    $show_combo = !empty($atts["show_combo"])?$atts["show_combo"]:"No";
    $show_button = !empty($atts["show_button"])?$atts["show_button"]:"Yes";
    $currency = whmp_get_currency(@$atts["currency"]);
    
    # Getting data from MySQL
    global $wpdb;
    $Q = "SELECT `name`,`description` FROM `".whmp_get_products_table_name()."` WHERE `id`=$id";
    $row = $wpdb->get_row($Q,ARRAY_A);
    
    # Generating OutputString
    if (strtolower($box_type)=="vertical") {
        $OutputString = "<h3>".$row["name"]."</h3>";
        $description = trim(strip_tags($row["description"]),"\n");
        $description = explode("\n",$description);
        $description = "<ul>\n<li>". implode("</li><li>",$description). "</li>\n</ul>";
        $OutputString .= $description;
        
        # Check if price is requested or not
        if (strtolower($show_price)=="yes") {
            $price = whmpress_price_function( array("id"=> $id, "billingcycle" => $billingcycle) );
            $OutputString .= "<h4>".$price."</h4>";
        }
        
        # Check if combo is requested or not
        if (strtolower($show_combo)=="yes") {
            $combo = whmpress_order_combo_function( array("id"=>$id, "show_button"=>"No") );
            $OutputString .= $combo;
        }
        
        # Check if button is requested or not
        if (strtolower($show_button)=="yes") {
            $button = whmpress_order_button_function( array("id"=>$id) );
            $OutputString .= $button;
        }
    } elseif (strtolower($box_type)=="horizontal") {
        $OutputString = "<h3>".$row["name"]."</h3>";
        $description = trim(strip_tags($row["description"]),"\n");
        $description = explode("\n",$description);
        $description = "<ul>\n<li>". implode("</li><li>",$description). "</li>\n</ul>";
        
        # Check if price is requested or not
        if (strtolower($show_price)=="yes") {
            $price = whmpress_price_function( array("id"=> $id, "billingcycle" => $billingcycle) );
        } else $price = "";
        
        # Check if combo is requested or not
        if (strtolower($show_combo)=="yes") {
            $combo = whmpress_order_combo_function( array("id"=>$id, "show_button"=>"No") );
        } else $combo = "";
        
        # Check if button is requested or not
        if (strtolower($show_button)=="yes") {
            $button = whmpress_order_button_function( array("id"=>$id) );
        } else $button = "";
        
        $OutputString .= "<div class='style1_wrapper'>
            <div style='float:left' class='style1_left'>
                $description
            </div>
            <div style='float:right' class='style1_right'>
                <h2>$price</h2>
                $combo
                $button
            </div>
            <div style='clear:both'></div>
        </div>";
    }
    
    # Returning output string with wrapper div
    return "<div id='$html_id' class='$html_class'>".$OutputString."</div>";
}

function whmpress_description_function($atts) {
/**
 * Shows service description
 * 
 * List of parameters
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * id = relid match from whmcs mysql table
 * show_as = display result in ul, ol
 */
 
    # Checking parameters
    $html_class = !empty($atts["html_class"])?$atts["html_class"]:"";
    $html_id = !empty($atts["html_id"])?$atts["html_id"]:"";
    $id = !empty($atts["id"])?$atts["id"]:"0";
    $show_as = !empty($atts["show_as"])?$atts["show_as"]:"";
    
    # Getting data from mysql tables
    global $wpdb;
    $Q = "SELECT `description` FROM `".whmp_get_products_table_name()."` WHERE `id`=$id";
    $description = $wpdb->get_var($Q);
    
    # Checking show_as parameter
    if (strtolower($show_as)=="ul" || strtolower($show_as)=="ol") {
        $description = trim(strip_tags($description),"\n");
        $description = explode("\n",$description);
        $description = "<".$show_as.">\n<li>". implode("</li><li>",$description). "</li>\n</".$show_as.">";
    }
    
    # Generating output string
    $OutputString = "<div id='$html_id' class='$html_class'>".$description."</div>";
    
    # Returning output string
    return $OutputString;
}

function whmpress_name_function($atts) {
/**
 * Shows service name
 * 
 * List of parameters
 * html_class = HTML class for wrapper
 * html_id = HTML id for wrapper
 * id = relid match from whmcs mysql table
 */
 
    # Checking parameters
    $html_class = !empty($atts["html_class"])?$atts["html_class"]:"";
    $html_id = !empty($atts["html_id"])?$atts["html_id"]:"";
    $id = !empty($atts["id"])?$atts["id"]:"0";
    
    # Getting data from mysql tables
    global $wpdb;
    $Q = "SELECT `name` FROM `".whmp_get_products_table_name()."` WHERE `id`=$id";
    $name = $wpdb->get_var($Q);
    
    # Generating output string
    $OutputString = "<div id='$html_id' class='$html_class'>".$name."</div>";
    
    # Returning output string
    return $OutputString;
}

function whmpress_price_function($atts) {
    //show_array($atts);
/**
 * Shows currency with prefix and suffix
 * 
 * List of parameters
 * currency = provide currency code
 * id = relid from mysql pricing table
 * html_class = html class name for wrapper
 * html_id = html id name for wrapper
 * billingcycle = select this column name from mysql pricing table
 * decimals = round number of decimals for price/amount
 * decimals_tag = html tag name for wrap decimals only
 * hide_decimal = yes for hide decimal symbol
 * prefix = show currency prefix, yes for show without any tag aur tag name to wrap.
 * suffix = show currency suffix, yes for show without any tag aur tag name to wrap.
 * show_duration = yes for show duration with price > Yes, No or tagname e.g. i
 * show_duration_as = long or short duration (year or yr)
 * convert_monthly = convert price into monthly price (yes or no)
 */
    # Getting WordPress DB variable for communicating with DB.
    global $wpdb;
    
    # Checking parameters
    $currency = whmp_get_currency(@$atts["currency"]);
    $id = !empty($atts["id"])?$atts["id"]:"0";
    $class = !empty($atts["html_class"])?$atts["html_class"]:""; if ($class=="whmpress-default" || $class=="") $class="whmpress_price";
    $billingcycle = !empty($atts["billingcycle"])?$atts["billingcycle"]:whmpress_get_option("billingcycle");
    $decimals = !empty($atts["decimals"])?$atts["decimals"]:whmpress_get_option("decimals");
    $decimals_tag = !empty($atts["decimals_tag"])?$atts["decimals_tag"]:whmpress_get_option("decimals_tag");
    $hide_decimal = !empty($atts["hide_decimal"])?$atts["hide_decimal"]:whmpress_get_option("hide_decimal");
    $prefix = !empty($atts["prefix"])?$atts["prefix"]:whmpress_get_option("prefix");
    $suffix = isset($atts["suffix"])?$atts["suffix"]:whmpress_get_option("suffix");
    $html_id = isset($atts["html_id"])?$atts["html_id"]:"";
    $show_duration = isset($atts["show_duration"])?$atts["show_duration"]:whmpress_get_option("show_duration");
    $show_duration_as = !empty($atts["show_duration_as"])?$atts["show_duration_as"]:whmpress_get_option("duration_type");
    $convert_monthly = !empty($atts["convert_monthly"])?$atts["convert_monthly"]:"no";
    
    # Getting price from DB
    $Q = "SELECT `{$billingcycle}` FROM `".whmp_get_pricing_table_name()."` WHERE `relid`='{$id}' AND `currency`='{$currency}' AND `type`='product'";
    $price = $wpdb->get_var($Q);
    
    # Checking that ID is valid or not
    if ($price===null || is_null($price)) return "Invalid ID";
    
    # Converting price into monthly price if required
    if (strtolower($convert_monthly)=="yes" && $billingcycle=="annually") $price = $price/12;
    elseif (strtolower($convert_monthly)=="yes" && $billingcycle=="quarterly") $price = $price/3;
    elseif (strtolower($convert_monthly)=="yes" && $billingcycle=="semiannually") $price = $price/6;
    elseif (strtolower($convert_monthly)=="yes" && $billingcycle=="biennially") $price = $price/24;
    elseif (strtolower($convert_monthly)=="yes" && $billingcycle=="triennially") $price = $price/36;
    
    # Setting decimals for price
    $price = number_format($price, $decimals);    
    if ($decimals_tag<>"") {
        $parts = explode(".",$price);
        if ($decimals>0)
            $parts[1] = "<{$decimals_tag}>." . (@$parts[1]) . "</{$decimals_tag}>";
        else
            $parts[1] = "";
        $price = @$parts[0] . @$parts[1];
        $price = rtrim($price,".");
    }
    
    # Remove decimal symbol if requested
    if (strtolower($hide_decimal)=="yes") {
        $price = str_replace(".","",$price);
    }
    
    # Generating string for output
    $return_string = "";
    if (strtolower($prefix)=="yes") $return_string .= whmp_get_currency_prefix($currency);
    elseif (strtolower($prefix)<>"" && strtolower($prefix)<>"no") $return_string .= "<{$prefix}>".whmp_get_currency_prefix($currency)."</{$prefix}>";
    $return_string .= $price;
    if (strtolower($suffix)=="yes") $return_string .= whmp_get_currency_suffix($currency);
    elseif (strtolower($suffix)<>"" && strtolower($suffix)<>"no") $return_string .= "<{$suffix}>".whmp_get_currency_suffix($currency)."</{$suffix}>";
    
    # Check show duration parameter check
    $BillingCycles = array("annually","monthly");
    $ReplaceLongBillingCycles = array("year","month");
    $ReplaceShortBillingCycles = array("yr","mo");
    if (strtolower($show_duration_as)=="short")
        $ShowedBillingCycle = str_replace($BillingCycles,$ReplaceShortBillingCycles,$billingcycle);
    else
        $ShowedBillingCycle = str_replace($BillingCycles,$ReplaceLongBillingCycles,$billingcycle);
    if (strtolower($convert_monthly)=="yes" && $show_duration_as=="short") $ShowedBillingCycle = "mo";
    elseif (strtolower($convert_monthly)=="yes") $ShowedBillingCycle = "month";
    
    if (strtolower($show_duration)=="yes")
        $return_string = "<span class='$class' id='{$html_id}'>".$return_string."/{$ShowedBillingCycle}</span>";
    elseif (strtolower($show_duration)<>"no" && $show_duration<>"")
        $return_string = "<span class='$class' id='{$html_id}'>".$return_string."<{$show_duration}>/{$ShowedBillingCycle}</{$show_duration}></span>";
    else
        $return_string = "<span class='$class' id='{$html_id}'>".$return_string."</span>";
    
    # Returning output string
    $decimal_sperator = get_option('decimal_replacement',".");
    return str_replace(".",$decimal_sperator,$return_string);
}


function whmpress_order_combo_function($atts) {
/**
 * Displays price of a WHMCS Service (Hosting Plan) for all billing cycle in dropdown list along with optional order button. Service id is the only required parameters
 * 
 * List of parameters
 * decimals = round number of decimals for price/amount
 * id = relid from mysql pricing table
 * currency = provide currency code
 * rows = How many rows for combo and button 1 or 2
 * show_discount = Whether to show discount or not
 * show_button = Show HTML button or not yes or no
 * button_text = HTML button text
 * combo_class = HTML class name for combo
 * button_class = HTML class for button
 * html_id = html id name for wrapper
 * html_class = HTML class name for wrapper
 * discount_type = What discout type required. yearly, monthly, quarterly etc.
 * billingcycles = What columns will display in combo e.g. yearly,monthly,biennially,semiannually,quarterly
 * prefix = show currency prefix, yes for show prefix
 * suffix = show currency suffix, yes for show suffix
 */
    # Getting WordPress DB variable for communicating with DB.
    global $wpdb;
    
    # Checking parameters
    $decimal = isset($atts["decimals"])?$atts["decimals"]:whmpress_get_option("combo_decimals");
    $id = !empty($atts["id"])?$atts["id"]:"0";    
    $currency = whmp_get_currency(@$atts["currency"]);
    $rows = !empty($atts["rows"])?$atts["rows"]:whmpress_get_option("combo_rows");
    $showdiscount = !empty($atts["show_discount"])?$atts["show_discount"]:whmpress_get_option("combo_show_discount");
    $showbutton = !empty($atts["show_button"])?$atts["show_button"]:whmpress_get_option("combo_show_button");
    $buttontext = !empty($atts["button_text"])?$atts["button_text"]:whmpress_get_option("combo_button_text");
    $combo_class = isset($atts["combo_class"])?$atts["combo_class"]:"";
    $button_class = isset($atts["button_class"])?$atts["button_class"]:"";
    $html_id = isset($atts["html_id"])?$atts["html_id"]:"";
    $html_class = isset($atts["html_class"])?$atts["html_class"]:""; if ($html_class=="whmpress-default" || $html_class=="") $html_class = "whmpress whmpress_order_combo";
    $discount_type = !empty($atts["discount_type"])?$atts["discount_type"]:whmpress_get_option('combo_discount_type');
    $billingcycles = isset($atts["billingcycles"])?$atts["billingcycles"]:whmpress_get_option("combo_billingcycles");
    $prefix = !empty($atts["prefix"])?$atts["prefix"]:whmpress_get_option("combo_prefix");
    $suffix = !empty($atts["suffix"])?$atts["suffix"]:whmpress_get_option("combo_suffix");
    
    # Getting currency symbol
    $suffcursymbol = "";
    $prefcursymbol = "";
    if (strtolower($prefix)=="yes") {
        $prefcursymbol = whmp_get_currency_prefix($currency);
    }
    if (strtolower($suffix)=="yes") {
        $suffcursymbol = whmp_get_currency_suffix($currency);
    }
    
    # Getting data from DB.
    if (is_array($billingcycles)) $billingcycles = trim(implode(",",$billingcycles));
    if (trim($billingcycles)<>"") {
        # Setting up billing cycles
        $billingcycles = explode(",",$billingcycles);
        $billingcycles = array_map('trim', $billingcycles);
        $billingcycles = array_map('strtolower', $billingcycles);
        $Q = "SELECT ". implode(",",$billingcycles) ." FROM `".whmp_get_pricing_table_name()."` WHERE `type`='product'";
    } else
        $Q = "SELECT `triennially`,`biennially`,`annually`,`semiannually`,`quarterly`,`monthly` FROM `".whmp_get_pricing_table_name()."` WHERE `type`='product'";
    if (isset($id)) $Q .= " AND `relid`=".$id;
    $Q .= " AND `currency`=".$currency;
    $row = $wpdb->get_row($Q,ARRAY_A);
    
    # Checking that provided ID is valid
    if ($row===false || !is_array($row)) return "Invalid ID";
    
    # Generating string for output
    $string = "
    <form action='".whmp_get_installation_url()."/cart.php'>
    <input type=\"hidden\" value=\"add\" name=\"a\">    
    <input type=\"hidden\" value=\"{$id}\" name=\"pid\">
    <input type=\"hidden\" value=\"{$currency}\" name=\"currency\"> 
    <select name=\"billingcycle\" class=\"{$combo_class}\">\n";
    if ($row["monthly"]>0) {
        if (strtolower($discount_type)=="yearly") {
            $string .= "<option value=\"annually\">1 Year - {$prefcursymbol}".round($row["monthly"],$decimal)."{$suffcursymbol}</option>";
        } else if (strtolower($discount_type)=="monthly") { 
            $string .= "<option value=\"monthly\">1 Month - {$prefcursymbol}".round($row["monthly"],$decimal)."{$suffcursymbol}/mo</option>";
        }
    }
    if ($row["quarterly"]>0) {
        if (strtolower($discount_type)=="yearly") {
            $string .= "<option value='annually'>1 Year - {$prefcursymbol}".round($row["quarterly"],$decimal)."{$suffcursymbol}</option>";
        } else {
            $monthly = round($row["quarterly"]/3,$decimal);
            $string .= "<option value=\"quarterly\">3 Months - {$prefcursymbol}".round($row["quarterly"],$decimal)."{$suffcursymbol} @ {$monthly}/mo</option>";
        }
    }
    if ($row["semiannually"]>0) {
        if (strtolower($discount_type)=="yearly") {
            $string .= "<option value=\"annually\">1 Year - {$prefcursymbol}".round($row["semiannually"],$decimal)."{$suffcursymbol}</option>";
        } else {
            $monthly = round($row["semiannually"]/6,$decimal);
            $string .= "<option value=\"semiannually\">6 Months - {$prefcursymbol}".round($row["semiannually"],$decimal)."{$suffcursymbol} @ {$monthly}/mo</option>";
        }
    }
    if ($row["annually"]>0) {
        if (strtolower($discount_type)=="yearly") {
            $string .= "<option value=\"annually\">1 Year - {$prefcursymbol}".round($row["annually"],$decimal)."{$suffcursymbol}</option>";
        } else {
            $monthly = round($row["annually"]/12,$decimal);
            $string .= "<option value=\"annually\">12 Months - {$prefcursymbol}".round($row["annually"],$decimal).$suffcursymbol;
            if (strtolower($showdiscount)=="yes") $string .= " @ {$monthly}/mo";
            $string .= "</option>";
        }
    }
    if ($row["biennially"]>0) {
        if (strtolower($discount_type)=="yearly") {
            $string .= "<option value=\"biennially\">2 Year - {$prefcursymbol}".round($row["biennially"],$decimal)."{$suffcursymbol}";
            if (strtolower($showdiscount)=="yes") $string .= " Save 10%";
            $string .= "</option>";
        } else {
            $monthly = round($row["biennially"]/24,$decimal);
            $string .= "<option value=\"biennially\">24 Months - {$prefcursymbol}".round($row["biennially"],$decimal).$suffcursymbol;
            if (strtolower($showdiscount)=="yes") $string .= " @ {$monthly}/mo";
            $string .= "</option>";
        }
    }
    if ($row["triennially"]>0) {
        if (strtolower($discount_type)=="yearly") {
            $string .= "<option value=\"triennially\">3 Year - {$prefcursymbol}".round($row["triennially"],$decimal)."{$suffcursymbol}";
            if (strtolower($showdiscount)=="yes") $string .= " Save 20%";
            $string .= "</option>";
        } else {
            $monthly = round($row["triennially"]/36,$decimal);
            $string .= "<option value=\"triennially\">36 Months - {$prefcursymbol}".round($row["triennially"],$decimal).$suffcursymbol;
            if (strtolower($showdiscount)=="yes") $string .= " @ {$monthly}/mo";
            $string .= "</option>";
        }
    }
    $string .= "</select>\n";
    if ($rows=="2") $string .= "<br />";
    if (strtolower($showbutton)=="yes") $string .= "<button class=\"{$button_class}\">{$buttontext}</button>";
    $string .= "</form>";
    
    # Returning output string including HTML wrapper with ID
    $decimal_sperator = get_option('decimal_replacement',".");
    return "<div id='$html_id' class='$html_class'>".str_replace(".",$decimal_sperator,$string)."</div>";
}

function whmpress_order_button_function($atts) {
/**
 * Displays order button
 * 
 * List of parameters
 * button_text = Button text
 * html_class = HTML class for button
 * id = WHMCS product ID from mysql table
 * billingcycle = Billing cycle e.g. annually
 * html_id = HTML id for button
 * currency = Currency ID
 */
 
    # Checking parameters
    $value = !empty($atts["button_text"])?$atts["button_text"]:"Order";
    $class = isset($atts["html_class"])?$atts["html_class"]:""; if ($class=="whmpress-default" || $class=="") $class = "whmpress_order_button";
    $id = !empty($atts["id"])?$atts["id"]:"0";
    $billingcycle = !empty($atts["billingcycle"])?$atts["billingcycle"]:"annually";
    $html_id = isset($atts["html_id"])?$atts["html_id"]:"";
    $currency = whmp_get_currency(@$atts["currency"]);
    
    # Generating URL.
    $url = whmp_get_installation_url()."/cart.php?pid={$id}&a=add&currency={$currency}&billingcycle={$billingcycle}";
    
    # Generating output string.
    $str = "<button type='button' id='$html_id' class=\"{$class}\" onclick=\"window.location.href='{$url}'\">{$value}</button>";
    
    # Returning output string
    return $str;
}

function whmpress_order_link_function($atts) {
/**
 * Displays order link
 * 
 * List of parameters
 * link_text = Link text
 * html_class = HTML class for link
 * id = WHMCS product ID from mysql table
 * billingcycle = Billing cycle e.g. annually
 * html_id = HTML id for link
 * currency = Currency ID
 */
 
    # Checking parameters
    $value = !empty($atts["link_text"])?$atts["link_text"]:"Order";
    $class = isset($atts["html_class"])?$atts["html_class"]:""; if ($class=="whmpress-default" || $class=="") $class = "whmpress_order_link";
    $id = !empty($atts["id"])?$atts["id"]:"0";
    $billingcycle = !empty($atts["billingcycle"])?$atts["billingcycle"]:"annually";
    $html_id = isset($atts["html_id"])?$atts["html_id"]:"";
    $currency = whmp_get_currency(@$atts["currency"]);
    
    # Generating URL.
    $url = whmp_get_installation_url()."/cart.php?pid={$id}&a=add&currency={$currency}&billingcycle={$billingcycle}";
    
    # Generating output string.
    $str = "<a id='$html_id' class=\"{$class}\" href=\"{$url}\">{$value}</a>";
    
    # Returning output string
    return $str;
}


function whmpress_order_url_function( $atts ) {
/**
 * Display/Generate order url
 * 
 * List of parameters
 * id = WHMCS product ID from mysql table
 * billingcycle = Billing cycle e.g. annually
 * currency = Currency ID
 */
    
    # Checking parameters
    if (!isset($atts["id"]) || empty($atts["id"]) || !is_numeric($atts["id"])) return whmp_get_installation_url();
    $id = $atts["id"];
    $billingcycle = !empty($atts["billingcycle"])?$atts["billingcycle"]:"annually";
    $currency = whmp_get_currency(@$atts["currency"]);
    
    # Generating order url and making output string
    $str = whmp_get_installation_url()."/cart.php?a=add&pid=".$id."&currency=".$currency."&billingcycle={$billingcycle}";
    
    # Returning output string
    return $str;
}

function whmpress_currency_function($atts) {
/**
 * Display currency symbol
 * 
 * List of attributes/parameters
 * html_id = HTML id for wrapper span
 * html_class = HTML class for wrapper span
 * show = suffix,prefix,code    (default prefix)
 */

    # Checking parameters
    $html_id = isset($atts["html_id"])?$atts["html_id"]:"";
    $html_class = isset($atts["html_class"])?$atts["html_class"]:""; if ($html_class=="whmpress-default" || $html_class=="") $html_class = "whmpress_currency";
    $show = isset($atts["show"])?$atts["show"]:""; if ($show=="") $show="prefix";
    
    # Getting currency
    if (!isset($_SESSION["currency"])) {
        $func = "whmp_get_default_currency_".strtolower($show);
        $currency = $func();
    } else {
        $func = "whmp_get_currency_".strtolower($show);
        $currency = $func($_SESSION["currency"]);
    }
    
    # Returning output including wrapper
    return "<span id='$html_id' class='$html_class'>" . $currency . "</span>";
}

function whmpress_currency_combo_function($atts) {
/**
 * Generate a currency combo and will change currency for prices
 * 
 * List of parameters
 * combo_name = HTML name for combo
 * combo_class = HTML class for combo
 * prefix = Display or not prefix with currency, e.g. $
 * html_id = HTML id for wrapper of combo
 * html_class = HTML class for wrapper of combo
 */
 
    # List of parameters
    $name = isset($atts["combo_name"])?$atts["combo_name"]:"";
    $class = isset($atts["combo_class"])?$atts["combo_class"]:"";
    $prefix = !empty($atts["prefix"])?$atts["prefix"]:"yes";
    $html_id = isset($atts["html_id"])?$atts["html_id"]:"";
    $html_class = isset($atts["html_class"])?$atts["html_class"]:""; if ($html_class=="whmpress-default" || $html_class=="") $html_class = "whmpress whmpress_currency_combo";
    
    # Getting WordPress DB object
    global $wpdb;
    
    # Checking currency
    if (isset($_SESSION["currency"])) $currency=$_SESSION["currency"];
    else {
        $currency = whmp_get_default_currency_id();
    }
    
    # getting ajax url which will change currency in session
    #$ajaxFile = WHMP_PLUGIN_URL."/includes/set_currency.php";
    
    # Generating random HTML id for combo
    $myID = "S".rand();
    
    # Generating output string
    $str = "
    <script>
        jQuery(function(){
        jQuery(\"#{$myID}\").change(function(){
            val = jQuery(this).val();
            jQuery.post(MyAjax.ajaxurl + '?setCurrency',{curency: val},function(data){
                if (data=='OK')
                    window.location.reload();
                else
                    alert(data);
            });
        });
    });
    </script>
    ";
    $str .= "<select id='$myID'";
    $str .= ' class="'.$class.'"';
    $str .= ' name="'.$name.'"';
    $str .= ">\n";
    
    $C = $currency;
    $Q = "SELECT `id`, `prefix`, `code` FROM `".whmp_get_currencies_table_name()."` ORDER BY `id`";
    $rows = $wpdb->get_results($Q);
    foreach($rows as $row) {
        $S = $C==$row->id?"selected=selected":"";
        $str .= "<option $S value='{$row->id}'>{$row->code}";
        if (strtolower($prefix)=="yes") $str .= " ({$row->prefix})";        
        $str .= "</option>";
    }
    $str .= "</select>";
    
    # Returning combo output string including wrapper div
    $decimal_sperator = get_option('decimal_replacement',".");
    return "<div id='$html_id' class='$html_class'>" . str_replace(".",$decimal_sperator,$str) . "</div>";
}

function whmpress_currency_combo_fancy_function() {
    if (isset($_SESSION["currency"])) $currency=$_SESSION["currency"];
    else {
        $currency = whmp_get_default_currency_id();
    }
    
    // Getting currencies
    global $wpdb;
    $Q = "SELECT `id`, `prefix`, `code` FROM `".whmp_get_currencies_table_name()."` ORDER BY `id`";
    $rows = $wpdb->get_results($Q,ARRAY_A);
    #print_r ($rows);
    
    // Adding flag if flag png available in extra folder
    foreach($rows as &$row) {
        if (file_exists(WHMP_PLUGIN_DIR."/extras/".$row["code"].".png"))
            $row["flag"] = WHMP_PLUGIN_URL."/extras/".$row["code"].".png";
        else
            $row["flag"] = WHMP_PLUGIN_URL."/extras/noflag.png";
    }
    
    // Setting current selected currency
    $topurl = "";
    foreach($rows as $r) {
        #print_r ($row);
        if ($currency==$r["id"]) {
            $topurl = '<a class="lang_sel_sel icl-en" href="#" onclick="return false;"><img title="'.
            $r["code"].
            ' ('.
            $r["prefix"].
            ')" alt="en" src="'.
            $r["flag"].
            '" class="iclflag">&nbsp;<span class="icl_lang_sel_current">'.
            $r["code"].
            ' ('.
            $r["prefix"].
            ')</span></a>';
            #break;
        }
    }
    
    $func_name = uniqid('func_');
    $str = '
    <div id="lang_sel">
        <ul>
            <li>
                '.$topurl.'
                <ul>';
                foreach($rows as $row1) {
                    $str .= "<li class=\"icl-pl\"><a href=\"#\" onclick=\"return ".
                    $func_name.
                    "(".
                    $row1["id"].
                    ");\" hreflang=\"pkr\" rel=\"alternate\"><img title=\"{$row1["code"]}\" alt=\"{$row1["code"]}\" src=\"".
                    $row1["flag"].
                    "\" class=\"iclflag\">&nbsp; <span class=\"icl_lang_sel_native\">{$row1["code"]} ({$row1["prefix"]})</span> <span class=\"icl_lang_sel_translated\"><span class=\"icl_lang_sel_native\">(</span>{$row["code"]}<span class=\"icl_lang_sel_native\">)</span></span></a></li>\n";
                }
                $str .= '</ul>
            </li>
        </ul>
    </div>
    
    <script>
        function '.$func_name.'(cur) {
            jQuery.post(MyAjax.ajaxurl + "?setCurrency",{curency:cur},function(data){
                if (data=="OK") window.location.reload();
                else alert(data);
            });
            return false;
        }
    </script>
    ';
    return $str;
}

function whmpress_domain_search_function($atts) {
    /**
     * Generates HTML form for search domains
     * 
     * List of parameters
     * show_tlds = provide comma seperated tlds e.g. .com,.net,.org or leave it blank for all tlds
     * show_tlds_wildcard = provide tld search as wildcard, e.g. pk for all .pk domains or co for all com and .co domains
     * show_combo = 1 or 0 for display or hide combo box of tlds
     * placeholder = HTML placeholder for input search box
     * text_class = HTML class for wrapper of input search box
     * combo_class = HTML class for wrapper of combo box
     * button_class = HTML class for wrapper of submit button of form
     * action = Specify url where form will submit
     * button_text = Button text for submit button
     * html_class = HTML class for wrapper of form
     * html_id = HTML id for wrapper of form
     */
     
    # Checking parameters
    $show_tlds = isset($atts["show_tlds"])?$atts["show_tlds"]:"";
    $show_tlds_wildcard = isset($atts["show_tlds_wildcard"])?$atts["show_tlds_wildcard"]:"";
    $show_combo = !empty($atts["show_combo"])?$atts["show_combo"]:"no";
    $placeholder = isset($atts["placeholder"])?$atts["placeholder"]:"";
    $text_class = isset($atts["text_class"])?$atts["text_class"]:"";
    $combo_class = isset($atts["combo_class"])?$atts["combo_class"]:"";
    $button_class = isset($atts["button_class"])?$atts["button_class"]:"";
    $action = !empty($atts["action"])?$atts["action"]:whmp_get_installation_url()."/domainchecker.php";
    $bt = !empty($atts["button_text"])?$atts["button_text"]:"Search";
    $html_class = isset($atts["html_class"])?$atts["html_class"]:""; if ($html_class=="whmpress-default" || $html_class=="") $html_class = "whmpress whmpress_domain_whois";
    $html_id = isset($atts["html_id"])?$atts["html_id"]:"";

    # Getting WordPress DB object
    global $wpdb;
    
    # Generating and setting combo box if it will display
    if (strtolower($show_combo)=="yes"):
        $Q = "SELECT `extension` FROM `".whmp_get_domain_pricing_table_name()."` WHERE 1";
        if ($show_tlds<>"") {
            $show_tlds = explode(",",$show_tlds);
            $Q .= " AND (`extension`='".implode("' OR `extension`='",$show_tlds)."')";
        } elseif ($show_tlds_wildcard<>"") {
            $Q .= " AND `extension` LIKE '%{$show_tlds_wildcard}%'";
        }
        $Q .= " ORDER BY `extension`";
        $rows = $wpdb->get_results($Q, ARRAY_A);
    endif;
    
    # Generating output string
    $str = "<form method=\"get\" id=\"searchDomainForm\" action=\"{$action}\" role=\"search\">
    <!--input type=\"hidden\" name=\"token\" value=\"24372f4f06ca835d9101d60a258c30a4c93b3bf7\">
    <input type=\"hidden\" name=\"direct\" value=\"true\"-->";
    $str .= "<div class=\"{$text_class}\">";
    $val = @$_GET["search_domain"];
    $str .= "<input required='required' type=\"search\" name=\"domain\" id=\"search_domain\" placeholder=\"{$placeholder}\" value=\"{$val}\" />\n";
    $str .= "</div>";
    if (strtolower($show_combo)=="yes"):
        $str .= "<div class=\"{$combo_class}\">";
        $str .= "<select name='ext'>";
        foreach($rows as $row) {
            $str .= "<option>".$row["extension"]."</option>\n";
        }
        $str .= "</select>";
        $str .= "</div>";
    else:
        $str .= "<input type='hidden' name='ext' value=''>\n";
    endif;
    $str .= "<div class=\"{$button_class}\">";
    $str.= "<input type=\"submit\" value=\"{$bt}\" >";
    $str .= "</div>";
    $str .= "</form>";
    
    # Returning output string including wrapper div
    return "<div class='$html_class' id='$html_id'>" . $str . "</div>";
}

function whmpress_price_table_domain_function($atts) {
/**
 * Displays customized price table only for domain
 * 
 * List of parameters
 * table_id = HTML id for HTML table.
 * html_id = HTML id for wrapper div of table.
 * html_class = HTML class for wrapper div of table.
 * currency = Set currency for prices, Leave this parameter for default currency.
 * hide_search = Yes or No for hide search
 * show_tlds = provide comma seperated tlds e.g. .com,.net,.org or leave it blank for all tlds
 * show_tlds_wildcard = provide tld search as wildcard, e.g. pk for all .pk domains or co for all com and .co domains
 * decimals = Decimals for price, default 2
 * cols = Number of columns for result in, default 1
 * show_renewel = Show domain renewel price, Yes or No
 * show_transfer = Show domain transfer price, Yes or No
 * titles = Comma separated titles for column titles
 * search_label = Set label for search
 * search_placeholder = Set placeholder for search box
 */
 
    # List of parameters
    //$years = isset($atts["years"])?$atts["years"]:"1";
    $table_id = !empty($atts["table_id"])?$atts["table_id"]:"prices_table2";
    $html_id = isset($atts["html_id"])?$atts["html_id"]:"";
    $html_class = isset($atts["html_class"])?$atts["html_class"]:""; if ($html_class=="whmpress-default" || $html_class=="") $html_class = "whmpress whmpress_price_matrix_domain";
    $hide_search = isset($atts["hide_search"])?$atts["hide_search"]:"";
    $currency = whmp_get_currency(@$atts["currency"]);
    $show_tlds = isset($atts["show_tlds"])?$atts["show_tlds"]:"";
    $show_tlds_wildcard = isset($atts["show_tlds_wildcard"])?$atts["show_tlds_wildcard"]:"";
    $decimals = isset($atts["decimals"])?$atts["decimals"]:"2"; $decimals = $decimals==""?"2":$decimals;
    $cols = isset($atts["cols"])?$atts["cols"]:"1";
    $show_renewel = isset($atts["show_renewel"])?$atts["show_renewel"]:"No";
    $show_transfer = isset($atts["show_transfer"])?$atts["show_transfer"]:"No";
    $titles = @$atts["titles"];
    $search_label = @$atts["search_label"]; if ($search_label=="") $search_label="Search:";
    $search_placeholder = @$atts["search_placeholder"]; if ($search_placeholder=="") $search_placeholder = "Search";
    
    # Getting WordPress DB object    
    global $wpdb;
    
    # Getting symbol type
    $symbol_type = strtolower(whmpress_get_option('default_currency_symbol'));
    
    # Getting data from database
    $c = "";
    
    
    $Q = "SELECT `extension`, `msetupfee`, `qsetupfee` FROM `".whmp_get_pricing_table_name()."` pt, `".whmp_get_domain_pricing_table_name()."` dpt WHERE dpt.id=`relid` AND
    `type`='[[[type]]]' AND `msetupfee`>-1 AND `currency`=".$currency;
    
    if (trim($show_tlds)<>"") {
        $show_tlds = explode(",",$show_tlds);
        $show_tlds = "'".implode("','",$show_tlds)."'";
        $Q .= " AND `extension` IN (".$show_tlds.")";
    } else if (trim($show_tlds_wildcard)<>"") $Q .= " AND `extension` LIKE '%".$show_tlds_wildcard."%'";
    $Q .= " ORDER BY `order`";
    
    $type = "domainregister";
    $rows = $wpdb->get_results(str_replace("[[[type]]]",$type,$Q), ARRAY_A);
    $type = "domainrenew";
    $rows2 = $wpdb->get_results(str_replace("[[[type]]]",$type,$Q), ARRAY_A);
    $type = "domaintransfer";
    $rows3 = $wpdb->get_results(str_replace("[[[type]]]",$type,$Q), ARRAY_A);
    
    # Generating output string
    $str = "";
    
    // Adding search box if hide_search is not called
    if (strtolower($hide_search)<>"yes") {
        $str .= "<script>
        jQuery(function(){
            jQuery('input#search_{$table_id}').quicksearch('table#{$table_id} tbody tr');
        });
        </script>
        <label>".$search_label."</label>
        <input type='search' placeholder='{$search_placeholder}' id='search_{$table_id}' style='width:50%' >";
    }
    
    $str .= "<table border='1'";
    $str .= " id=\"".$table_id."\"";
    $str .= ">\n<thead><tr>";
    
    for($c=1; $c<=$cols; $c++) {
        $titles = explode(",",$titles);
        if (isset($titles[0]) && $titles[0]<>"")
            $str .= "<th>".trim($titles[0])."</th>";
        else
            $str .= "<th>Domain</th>";
        
        if (isset($titles[1]))
            $str .= "<th>".trim($titles[1])."</th>";
        else
            $str .= "<th>Price/Year</th>";
            
        if ($show_renewel=="1" || strtolower($show_renewel)=="yes" || $show_renewel===true)
            $str .= "<th>Renewel Price</th>";
        if ($show_transfer=="1" || strtolower($show_transfer)=="yes" || $show_transfer===true)
            $str .= "<th>Transfer Price</th>";
    }
    $str .= "</tr></thead>\n";
    $str .= "<tbody>
    <tr>";
    
    # Getting decimal seperator from settings
    $decimal_sperator = get_option('decimal_replacement',".");
    
    foreach($rows as $index=>$domain) {
        //$str .= 'index+1 % cols = '.(($index+1) % $cols);
        $str .= "<td>".$domain['extension']."</td>";
        if ($domain['msetupfee']>0) {
            $v = str_replace(".",$decimal_sperator,number_format($domain['msetupfee'],$decimals));
        } else {
            $v = str_replace(".",$decimal_sperator,number_format($domain['qsetupfee'],$decimals));
        }
        
        if ($symbol_type=="prefix") $v = whmp_get_currency_prefix($currency).$v;
        elseif ($symbol_type=="suffix") $v = $v.whmp_get_currency_suffix($currency);
        elseif ($symbol_type=="code") $v = whmp_get_currency_code($currency)." $v";
        $str .= "<td>$v</td>";
        
        if ($show_renewel=="1" || strtolower($show_renewel)=="yes" || $show_renewel===true) {
            if ($rows2[$index]['msetupfee']>0) {
                $v = str_replace(".",$decimal_sperator,number_format($rows2[$index]['msetupfee'],$decimals));
            } else {
                $v = str_replace(".",$decimal_sperator,number_format($rows2[$index]['qsetupfee'],$decimals));
            }
            
            if ($symbol_type=="prefix") $v = whmp_get_currency_prefix($currency).$v;
            elseif ($symbol_type=="suffix") $v = $v.whmp_get_currency_suffix($currency);
            elseif ($symbol_type=="code") $v = whmp_get_currency_code($currency)." $v";
            $str .= "<td>$v</td>";
        }
        
        if ($show_transfer=="1" || strtolower($show_transfer)=="yes" || $show_transfer===true) {
            if ($rows3[$index]['msetupfee']>0) {
                $v = str_replace(".",$decimal_sperator,number_format($rows3[$index]['msetupfee'],$decimals));
            } else {
                $v = str_replace(".",$decimal_sperator,number_format($rows3[$index]['qsetupfee'],$decimals));
            }
            
            if ($symbol_type=="prefix") $v = whmp_get_currency_prefix($currency).$v;
            elseif ($symbol_type=="suffix") $v = $v.whmp_get_currency_suffix($currency);
            elseif ($symbol_type=="code") $v = whmp_get_currency_code($currency)." $v";
            $str .= "<td>$v</td>";
        }
        if (($index+1) % $cols==0) $str .= "</tr><tr>";
    }
    $str .= "</tbody>\n</table>
    ";
    
    # Returning output string including output wrapper div.
    return "<div id='$html_id' class='$html_class'>". $str . "</div>";
}

function whmpress_price_table_function($atts) {
/**
 * Displays price table of all services including domain
 * 
 * name = Matching service name
 * groups = comma seperated group names
 * billingcycles = Billing cycle names
 * decimals = number of decimals with price
 * type = type of product. e.g. product
 * table_id = HTML id for table
 * currency = Currency id for prices
 * show_hidden = provide yes if you want to show hidden products
 * replace_zero = replace zero with specific character, default is -
 * replace_empty = replace empty with specific character, default is x
 * html_id = HTML id for div wrapper
 * html_class = HTML class for div wrapper
 * hide_search = Yes or No for hide search
 * titles = Comman seprated titles for column titles
 * search_label = Set label for search
 * search_placeholder = Set placeholder for search box
 */
    
    # Checking parameters
    $name = isset($atts["name"])?$atts["name"]:"";
    $group = isset($atts["groups"])?$atts["groups"]:"";
    $cols = isset($atts["billingcycles"])?$atts["billingcycles"]:"";
    $decimals = !empty($atts["decimals"])?$atts["decimals"]:"0";
    $showhidden = !empty($atts["show_hidden"])?$atts["show_hidden"]:"no";
    $replacezero = !empty($atts["replace_zero"])?$atts["replace_zero"]:"x";
    $replaceempty = !empty($atts["replace_empty"])?$atts["replace_empty"]:"-";
    $table_id = !empty($atts["table_id"])?$atts["table_id"]:"prices_table";
    $type = !empty($atts["type"])?$atts["type"]:"product";
    $html_id = isset($atts["html_id"])?$atts["html_id"]:"";
    $html_class = isset($atts["html_class"])?$atts["html_class"]:""; if ($html_class=="whmpress-default" || $html_class=="") $html_class = "whmpress whmpress_price_matrix";
    $hide_search = isset($atts["hide_search"])?$atts["hide_search"]:"";
    $currency = whmp_get_currency(@$atts["currency"]);
    $titles = @$atts["titles"];
    $search_label = @$atts["search_label"]; if ($search_label=="") $search_label="Search:";
    $search_placeholder = @$atts["search_placeholder"]; if ($search_placeholder=="") $search_placeholder = "Search";
    
    # Getting WordPress DB object
    global $wpdb;
    
    # Getting symbol type
    $symbol_type = strtolower(whmpress_get_option('default_currency_symbol'));
    
    # Setting fields/columns for Table
    $fieldss = array(
        "sr"=>"Sr",
        "id"=>"ID",
        "name"=>"Name",
        "groupn"=>"Group",
        "monthly"=>"Monthly",
        "quarterly"=>"3 Months",
        "semiannually"=>"6 Months",
        "annually"=>"Yearly",
        "biennially"=>"2 Years",
        "triennially"=>"3 Years"
    );
    $dfieldss = array(          // Deletable fields
        "monthly"=>"Monthly",
        "quarterly"=>"3 Months",
        "semiannually"=>"6 Months",
        "annually"=>"Yearly",
        "biennially"=>"2 Years",
        "triennially"=>"3 Years"
    );
    $fields = "pd.`id`,pd.`name`,g.`name` groupn,pr.`monthly`,pr.`quarterly`,pr.`semiannually`,pr.`annually`,pr.`biennially`,pr.`triennially`,`gid`";
    
    # Getting data from DB
    $Q = "SELECT $fields FROM `".whmp_get_pricing_table_name()."` pr, `".whmp_get_products_table_name()."` pd, `".whmp_get_product_group_table_name()."` g
    WHERE pr.`currency`='$currency' AND pr.`relid`=pd.`id`";
    if ($name<>"") $Q .= " AND pd.`name` LIKE '%{$name}%'";
    if ($group<>"") {
        $group = explode(",",$group);
        $Q .= " AND (";
        foreach($group as $g) {
            if (is_numeric($g)) $Q .= "g.`id`='".$g."' OR ";
            else $Q .= "g.`name`='".$g."' OR ";
        }
        $Q = substr($Q,0,-4).")";
        //$Q .= " g.`name`='".implode("' OR g.`name`='",$group)."')";
    }
    if (strtolower($showhidden)=="no") $Q .= " AND pd.`hidden`<>'on' ";
    $Q .= " AND pd.gid=g.id AND pr.`type`='{$type}'
    ORDER BY pd.`gid`, pd.`name`";
    
    # Generating output string
    if ($cols<>"") {
        unset($fieldss["monthly"],$fieldss["quarterly"],$fieldss["semiannually"],$fieldss["annually"],$fieldss["biennially"],$fieldss["triennially"]);        
        $cols = explode(",",$cols);
        foreach($cols as $col) {
            $fieldss[trim($col)] = $dfieldss[trim($col)];
        }
    }
    $str = "";
    
    # Getting decimal seperator from settings
    $decimal_sperator = get_option('decimal_replacement',".");
    
    # Adding search box if hide_search is not called
    if (strtolower($hide_search)<>"yes") {
        $str .= "<script>
        jQuery(function(){
            jQuery('input#search_price_table').quicksearch('table#{$table_id} tbody tr');
        });
        </script>
        <label>{$search_label}</label>
        <input type='search' placeholder='{$search_placeholder}' id='search_price_table' style='width:50%' >";
    }
    
    $rows = $wpdb->get_results($Q,ARRAY_A);
    $str .= "<table style='width:100%' border='1' id='{$table_id}'>
    <thead>
        <tr>";
        $titles = explode(",",$titles);
        $x=0;
        foreach($fieldss as $k=>$field) {
            if (isset($titles[$x])) $t = trim($titles[$x]);
            else $t = trim($field,"`");
            $str .= "<th>".$t."</th>";
            
            $x++;
        }
    $str .= "</tr>
    </thead>
    <tbody>";
    foreach($rows as $key=>$row) {
        $str .= "<tr>";
        $str .= "<td>".($key+1)."</td>";
        foreach($fieldss as $k=>$field) {
            if ($k<>"sr") {
                $v = $row[$k];
                if ($v=="0.00") $v=$replacezero;
                if ($v=="-1.00") $v=$replaceempty;
                if (is_numeric($v)) $v=str_replace(".",$decimal_sperator,number_format($v,$decimals));
                if ($v<>$replaceempty && !($k=="id" || $k=="name" || $k=="groupn")) {
                    if ($symbol_type=="prefix") $v = whmp_get_currency_prefix($currency)."$v";
                    elseif ($symbol_type=="suffix") $v = "$v".whmp_get_currency_suffix($suffix);
                    elseif ($symbol_type=="code") $v = whmp_get_currency_code($currency)." $v";
                }
                $str .= "<td>".$v."</td>";
            }
        }
        $str .= "</tr>";
    }
    $str .= "
    </tbody>
    </table>";
    
    # Returning output string including wrapper div
    return "<div id='$html_id' class='$html_class'>" . $str . "</div>";
}

/*
function whmpress_geek_function( $atts ) {
    global $wpdb;
    $currency = whmp_get_currency(@$atts["currency"]);
    if (!isset($atts["type"])) $atts["type"]="product";
    if (!isset($atts["show"])) $atts["show"]="annually";
    if (!isset($atts["decimal"])) $atts["decimal"]=0;
    if (isset($atts["sup"]) && ($atts["sup"]==="1" || $atts["sup"]===true)) $atts["sup"]=1; else $atts["sup"]=0;
    
    $c = "";
    $Q = "SELECT * FROM `{$wpdb->prefix}tblpricing` WHERE 1";
    foreach($atts as $k=>$v) {
        if ($k<>"show" && $k<>"decimal" && $k<>"sup")
            $Q .= $wpdb->prepare( " AND `$k` = %s", $v  );
    }
    
    $rows = $wpdb->get_results($Q, ARRAY_A);
    if (isset($rows[0]) && is_array($rows[0])) {
        $rows[0]["curr"] = whmp_get_currency_prefix($currency);
        $rows[0]["annuallym"] = round($rows[0]["annually"]/12,$atts["decimal"]);
        $rows[0]["biennially"] = round($rows[0]["biennially"],$atts["decimal"]);
        $rows[0]["annually"] = round($rows[0]["annually"],$atts["decimal"]);
        $rows[0]["monthly"] = round($rows[0]["monthly"],$atts["decimal"]);
        $string = @$rows[0][$atts["show"]];
        if ($atts["sup"]=="1") {
            $p = explode(".",$string);
            $p[1] = "<sup>".@$p[1]."</sup>";
            return @$p[0].$p[1];
        } else {
            return $string;
        }
    } else {
        //return $wpdb->last_error;
        return "N/A";
    }
} */

/*
function whmp_shortcode_cmonthly($atts) {
    // Params > relid, 
    global $wpdb;
    if (!isset($atts["decimal"])) $atts["decimal"]=0;
    $currency = whmp_get_currency(@$atts["currency"]);
    
    $Q = "SELECT `triennially`,`biennially`,`annually`,`semiannually`,`quarterly`,`monthly` FROM `{$wpdb->prefix}tblpricing` WHERE `type`='product'";
    if (isset($atts["relid"])) $Q .= " AND `relid`=".$atts["relid"];
    $Q .= " AND `currency`=".$currency;
    $row = $wpdb->get_row($Q,ARRAY_A);
    if ($row["triennially"]>0) $str = round($row["triennially"]/36,$atts["decimal"]);
    else if ($row["biennially"]>0) $str = round($row["biennially"]/24,$atts["decimal"]);
    else if ($row["annually"]>0) $str = round($row["annually"]/12,$atts["decimal"]);
    else if ($row["semiannually"]>0) $str = round($row["semiannually"]/6,$atts["decimal"]);
    else if ($row["quarterly"]>0) $str = round($row["quarterly"]/3,$atts["decimal"]);
    else $str = $row["monthly"];
    
    return $str;
}*/

/*
function whmp_shortcode_yearly($atts) {
    // Params > relid, 
    global $wpdb;
    if (!isset($atts["decimal"])) $atts["decimal"]=0;
    if (!isset($atts["currency"]) && isset($_SESSION["currency"])) $currency=$_SESSION["currency"];
    elseif (!isset($atts["currency"])) $currency = whmp_get_default_currency_id();
    else $currency = $atts["currency"];
    
    $Q = "SELECT `annually` FROM `{$wpdb->prefix}tblpricing` WHERE `type`='product'";
    if (isset($atts["relid"])) $Q .= " AND `relid`=".$atts["relid"];
    $Q .= " AND `currency`=".$currency;
    $row = $wpdb->get_row($Q,ARRAY_A);
    
    $str = round($row["annually"],$atts["decimal"]);
    
    return $str;
}*/